/*	main.c		*/
#include "header.h"
static char copyright[]="Larn is copyrighted 1986 by Noah Morgan.\n";
#include <pwd.h>
struct passwd *getpwnam();
static struct passwd *_pass;
extern short playerx,playery,hitp[MAXX][MAXY];
extern char level,VERSION,SUBVERSION,cheat,predostuff,nosignal,always;
extern int c[],skill[],cbak[],gtime,yrepcount,dayplay;
extern char item[MAXX][MAXY],lastmonst[],objnamelist[],spelknow[];
extern char know[MAXX][MAXY],mitem[MAXX][MAXY];
extern char iven[],ivenarg[],*scrollname[],*potionname[],*objectname[];
extern char iarg[MAXX][MAXY],boldon,sex,psname[];
extern char monstnamelist[],stealth[MAXX][MAXY],*ckpfile,savefilename[];
extern short hit2flag,hitflag;
extern char wizard;	/*	the wizard mode flag	*/
extern struct monst monster[];
extern struct cel *cell;
extern int outstanding_taxes;
extern char scorefile[],logfile[],helpfile[],larnlevels[],fortfile[];
extern char mail601[],mail602[],mail603[],mail604[],mail605[];
extern char	loginname[], logname[];
int srcount=0;	/* line counter for showstr()	*/
int dropflag=0; /* if 1 then dont lookforobject() next round */
int rmst=80;	/*	random monster creation counter		*/
int userid;		/* the players login user id number */
extern int wisid;	/* the wizards id */
char nowelcome=0,nomove=0; /* if (nomove) then dont count next iteration as a move */
static char username[40],viewflag=0;
	/*	if viewflag then we have done a 99 stay here and dont showcell in the main loop */
char restorflag=0;	/* 1 means restore has been done	*/
static char *termtypes[] = { "vt100", "vt101", "vt102", "vt103", "vt131", "vt180", "vt220", "vt240", "vt241" };
/*
	************
	MAIN PROGRAM
	************
 */
main(argc,argv)
	int argc;
	char **argv;
	{
	register int i;
	int j,hard;
	char *ttype,*getenv(),*ptr,*getlogin();
	struct cel *malloc();
	userid = getuid();	/* obtain the user's login id number */
	if ((ptr = getlogin()) == 0)
		if ((ptr = getenv("USER")) == 0)
			if ((ptr = getenv("LOGNAME")) == 0)
				{ write(1, "Who Are You?\n", 13); exit(1);}

	strcpy(loginname,ptr);
	strcpy(logname,ptr);
#ifdef SAVEINHOME
	if ((ptr = getenv("HOME")) == 0)
		ptr == "";
	strcpy(savefilename, ptr);
	strcat(savefilename, "/Larn.sav");
#else
	strcat(savefilename,ptr);	/* prepare savefile name */
#endif
	fixstrings();
	cell = malloc(sizeof(struct cel)*(MAXLEVEL+MAXVLEVEL)*MAXX*MAXY);
	if (cell == 0) died(-285);	/* malloc failure */
	lpbuf    = (char *)malloc((5* BUFBIG)>>2);	/* output buffer */
	inbuffer = (char *)malloc((5*MAXIBUF)>>2);	/* output buffer */
	if ((lpbuf==0) || (inbuffer==0)) died(-285); /* malloc() failure */
	readopts();
#ifdef HIDEBYLINK
	if (strcmp(psname,"larn")) /* if a different process name only */
		{
		if ((i=access(psname,1)) < 0)
			{		/* link not there */
			if (link(argv[0],psname)>=0)
				{
				argv[0] = psname;   execv(psname,argv);
				}
			}
		else 
			{
			unlink(psname);
			}
		}
#endif HIDEBYLINK

#ifdef TIMECHECK
	if (dayplay==0)	/* check for not-during-daytime-hours */
	  if (playable())
		{
		write(2,"Sorry, Larn can not be played during working hours. (9-12AM, 1-5PM)\n",68);
		exit();
		}
#endif TIMECHECK

	lcreat(0);	newgame();		/*	set the initial clock  */ hard= -1;
	ttype = getenv("TERM");
	for (j=1, i=0; i<sizeof(termtypes)/sizeof(char *); i++)
		if (strcmp(ttype,termtypes[i]) == 0) { j=0;  break; }
	if (j)
		{
		lprcat("Sorry, Larn needs a VT100 family terminal for all it's features.\n"); lflush();
		exit();
		}
	for (i=1; i<argc; i++)
		{
		if (argv[i][0] == '-')
		  switch(argv[i][1])
			{
			case 's': /* show scoreboard   */  showscores();	exit();	
			case 'l': /* show log file     */
						if (userid!=wisid) 	/* show log file if wizard id */
							{
							lprcat("Sorry, the log file is not available.");
							lflush();  exit();
							}
						diedlog();		exit();

			case 'i': /*show all scoreboard*/  showallscores();	exit();
			case 'c': if (userid!=wisid) 	/* only wizard id can create scoreboard */
							{
							printf("userid = %d, wisid = %d\n", userid, wisid);
							lprcat("Sorry, you are not empowered to create the scoreboard.\n");
							lflush();  exit();
							}
					  lprcat("Preparing to initialize the scoreboard.\n");
					  if (getpassword() != 0)  /*make new scoreboard*/
							{
							makeboard(); lprc('\n'); showscores();
							}
					  exit();

			case 'n':	/* no welcome msg	*/ nowelcome=1; argv[i][0]=0; break;
			case '0': case '1': case '2': case '3': case '4': case '5':
			case '6': case '7': case '8': case '9':	/* for hardness */
						sscanf(&argv[i][1],"%d",&hard);	
						szero(argv[i]); break;
			};
		if (argv[i][0] == '+')
			{
			clear();	restorflag = 1;
			if (argv[i][1] == '+') { hitflag=1; restoregame(ckpfile); } /* restore checkpointed game	*/
				else  { hitflag=1; restoregame(savefilename); }  /* restore last game	*/
			szero(argv[i]);	i = argc;
			}
		}

	if (access(savefilename,0)==0)	/* restore game if need to */
		{
		clear();	restorflag = 1;
		hitflag=1;	restoregame(savefilename);  /* restore last game	*/
		}
	sigsetup();		/* trap all needed signals	*/
	sethard(hard);	/* set up the desired difficulty				*/
	setupvt100();	/*	setup the terminal special mode				*/
	if (c[HP]==0)	/* create new game */
		{
		makeplayer();	/*	make the character that will play			*/
		newcavelevel(0);/*	make the dungeon						 	*/
		predostuff = 1;	/* tell signals that we are in the welcome screen */
		if (nowelcome==0) welcome();	 /* welcome the player to the game */
		}
	drawscreen();	/*	show the initial dungeon					*/
	predostuff = 2;	/* tell the trap functions that they must do a showplayer()
						from here on */
	/* nice(1);	/* games should be run niced */
	yrepcount = hit2flag = 0;
	while (1)
		{
		if (dropflag==0) lookforobject(); /* see if there is an object here	*/
			else dropflag=0; /* dont show it just dropped an item */
		if (hitflag==0) { if (c[HASTEMONST]) movemonst(); movemonst(); }	/*	move the monsters		*/
		if (viewflag==0) showcell(playerx,playery); else viewflag=0;	/*	show stuff around player	*/
		hitflag=0;	nomove=1;
		bot_linex();	/* update bottom line */
		while (nomove) { nomove=0; parse(); }	/*	get commands and make moves	*/
		regen();			/*	regenerate hp and spells			*/
		if (c[TIMESTOP]==0)
			if (--rmst <= 0)
				{ rmst = 120-(level<<2); fillmonst(makemonst(level)); }
		}
	}

/*
	showstr()

	show character's inventory
 */
showstr()
	{
	register int i,number;
	for (number=3, i=0; i<26; i++)
		if (iven[i]) number++;	/* count items in inventory */
	t_setup(number);	qshowstr();	  t_endup(number);
	}

qshowstr()
	{
	register int i,j,k,sigsav;
	srcount=0;  sigsav=nosignal;  nosignal=1; /* dont allow ^c etc */
	if (c[GOLD]) { lprintf(".)   %d gold pieces",c[GOLD]); srcount++; }
	for (k=26; k>=0; k--)
	  if (iven[k])
		{  for (i=22; i<84; i++)
			 for (j=0; j<=k; j++)  if (i==iven[j])  show3(j); k=0; }

	lprintf("\nElapsed time is %d.  You have %d mobuls left",(gtime+99)/100+1,(TIMELIMIT-gtime)/100);
	more();		nosignal=sigsav;
	}

/*
 *	subroutine to clear screen depending on # lines to display
 */
t_setup(count)
	register int count;
	{
	if (count<22)  /* how do we clear the screen? */
		{
		cursor(79,count);  lprcat("\33[1J");  cursor(1,1);
		}
	else
		{
		resetscroll(); clear();
		}
	}

/*
 *	subroutine to restore normal display screen depending on t_setup()
 */
t_endup(count)
	register int count;
	{
	if (count<22)  /* how did we clear the screen? */
		{
		if (count>17)  /* clear the scrolling region too */
			{
			cursor(79,count);  lprcat("\33[1J"); 
			}
		draws(0,MAXX,0,(count>MAXY) ? MAXY : count);
		}
	else
		{
		drawscreen(); setscroll();
		}
	}

/*
	function to show the things player is wearing only
 */
showwear()
	{
	register int i,j,k,sigsav,count;
	sigsav=nosignal;  nosignal=1; /* dont allow ^c etc */
	srcount=0;

	 for (count=2,j=0; j<=26; j++)	 /* count number of items we will display */
	   if (i=iven[j])
		switch(i)
			{
			case OLEATHER:	case OPLATE:	case OCHAIN:
			case ORING:		case OSTUDLEATHER:	case OSPLINT:
			case OPLATEARMOR:	case OSSPLATE:	case OSHIELD:
			count++;
			};

	t_setup(count);

	for (i=22; i<84; i++)
		 for (j=0; j<=26; j++)
		   if (i==iven[j])
			switch(i)
				{
				case OLEATHER:	case OPLATE:	case OCHAIN:
				case ORING:		case OSTUDLEATHER:	case OSPLINT:
				case OPLATEARMOR:	case OSSPLATE:	case OSHIELD:
				show3(j);
				};
	more();		nosignal=sigsav;	t_endup(count);
	}

/*
	function to show the things player can wield only 
 */
showwield()
	{
	register int i,j,k,sigsav,count;
	sigsav=nosignal;  nosignal=1; /* dont allow ^c etc */
	srcount=0;

	 for (count=2,j=0; j<=26; j++)	/* count how many items */
	   if (i=iven[j])
		switch(i)
			{
			case ODIAMOND:  case ORUBY:  case OEMERALD:  case OSAPHIRE:
			case OBOOK:     case OCHEST:  case OLARNEYE: case ONOTHEFT:
			case OSPIRITSCARAB:  case OCUBEofUNDEAD:
			case OPOTION:   case OSCROLL:  break;
			default:  count++;
			};

	t_setup(count);

	for (i=22; i<84; i++)
		 for (j=0; j<=26; j++)
		   if (i==iven[j])
			switch(i)
				{
				case ODIAMOND:  case ORUBY:  case OEMERALD:  case OSAPHIRE:
				case OBOOK:     case OCHEST:  case OLARNEYE: case ONOTHEFT:
				case OSPIRITSCARAB:  case OCUBEofUNDEAD:
				case OPOTION:   case OSCROLL:  break;
				default:  show3(j);
				};
	more();		nosignal=sigsav;	t_endup(count);
	}

/*
	function to show the things player can read only
 */
showread()
	{
	register int i,j,k,sigsav,count;
	sigsav=nosignal;  nosignal=1; /* dont allow ^c etc */
	srcount=0;

	for (count=2,j=0; j<=26; j++)
		switch(iven[j])
			{
			case OBOOK:	case OSCROLL:	count++;
			};
	t_setup(count);

	for (i=22; i<84; i++)
		 for (j=0; j<=26; j++)
		   if (i==iven[j])
			switch(i)
				{
				case OBOOK:	case OSCROLL:	show3(j);
				};
	more();		nosignal=sigsav;	t_endup(count);
	}

/*
	function to show the things player can eat only
 */
showeat()
	{
	register int i,j,k,sigsav,count;
	sigsav=nosignal;  nosignal=1; /* dont allow ^c etc */
	srcount=0;

	for (count=2,j=0; j<=26; j++)
		switch(iven[j])
			{
			case OCOOKIE:	count++;
			};
	t_setup(count);

	for (i=22; i<84; i++)
		 for (j=0; j<=26; j++)
		   if (i==iven[j])
			switch(i)
				{
				case OCOOKIE:	show3(j);
				};
	more();		nosignal=sigsav;	t_endup(count);
	}

/*
	function to show the things player can quaff only
 */
showquaff()
	{
	register int i,j,k,sigsav,count;
	sigsav=nosignal;  nosignal=1; /* dont allow ^c etc */
	srcount=0;

	for (count=2,j=0; j<=26; j++)
		switch(iven[j])
			{
			case OPOTION:	count++;
			};
	t_setup(count);

	for (i=22; i<84; i++)
		 for (j=0; j<=26; j++)
		   if (i==iven[j])
			switch(i)
				{
				case OPOTION:	show3(j);
				};
	more();		nosignal=sigsav;		t_endup(count);
	}

show1(idx,str2)
	register int idx;
	register char *str2[];
	{
	if (str2==0)  lprintf("\n%c)   %s",idx+'a',objectname[iven[idx]]);
	else if (*str2[ivenarg[idx]]==0)  lprintf("\n%c)   %s",idx+'a',objectname[iven[idx]]);
	else lprintf("\n%c)   %s of%s",idx+'a',objectname[iven[idx]],str2[ivenarg[idx]]);
	}

show3(index)
	register int index;
	{
	switch(iven[index]) 
		{
		case OPOTION:	show1(index,potionname);  break;
		case OSCROLL:	show1(index,scrollname);  break;

		case OLARNEYE:		case OBOOK:			case OSPIRITSCARAB:
		case ODIAMOND:		case ORUBY:			case OCUBEofUNDEAD:
		case OEMERALD:		case OCHEST:		case OCOOKIE:
		case OSAPHIRE:		case ONOTHEFT:		show1(index,0);  break;

		default:		lprintf("\n%c)   %s",index+'a',objectname[iven[index]]);
						if (ivenarg[index]>0) lprintf(" + %d",ivenarg[index]);
						else if (ivenarg[index]<0) lprintf(" %d",ivenarg[index]);
						break;
		}
	if (c[WIELD]==index) lprcat(" (weapon in hand)");
	if ((c[WEAR]==index) || (c[SHIELD]==index))  lprcat(" (being worn)");
	if (++srcount>=22) { srcount=0; more(); clear(); }
	}

/*
	subroutine to randomly create monsters if needed
 */
randmonst()
	{
	if (c[TIMESTOP]) return;	/*	dont make monsters if time is stopped	*/
	if (--rmst <= 0)
		{
		rmst = 120 - (level<<2);  fillmonst(makemonst(level));
		}
	}


/*
	parse()

	get and execute a command
 */
parse()
	{
	register int i,j,k,flag;
	while	(1)
		{
		k = yylex();
		switch(k)	/*	get the token from the input and switch on it	*/
			{
			case 'h':	moveplayer(4);	return;		/*	west		*/
			case 'H':	run(4);			return;		/*	west		*/
			case 'l':	moveplayer(2);	return;		/*	east		*/
			case 'L':	run(2);			return;		/*	east		*/
			case 'j':	moveplayer(1);	return;		/*	south		*/
			case 'J':	run(1);			return;		/*	south		*/
			case 'k':	moveplayer(3);	return;		/*	north		*/
			case 'K':	run(3);			return;		/*	north		*/
			case 'u':	moveplayer(5);	return;		/*	northeast	*/
			case 'U':	run(5);			return;		/*	northeast	*/
			case 'y':	moveplayer(6);  return;		/*	northwest	*/
			case 'Y':	run(6);			return;		/*	northwest	*/
			case 'n':	moveplayer(7);	return;		/*	southeast	*/
			case 'N':	run(7);			return;		/*	southeast	*/
			case 'b':	moveplayer(8);	return;		/*	southwest	*/
			case 'B':	run(8);			return;		/*	southwest	*/

			case '.':	if (yrepcount) viewflag=1; return;		/*	stay here		*/

			case 'w':	yrepcount=0;	wield();	return;		/*	wield a weapon */

			case 'W':	yrepcount=0;	wear();		return;	/*	wear armor	*/

			case 'r':	yrepcount=0;
						if (c[BLINDCOUNT]) { cursor(1,21); lprcat("\nYou can't read anything when you're blind!"); } else
						if (c[TIMESTOP]==0) readscr(); return;		/*	to read a scroll	*/

			case 'q':	yrepcount=0;	if (c[TIMESTOP]==0) quaff();	return;	/*	quaff a potion		*/

			case 'd':	yrepcount=0;	if (c[TIMESTOP]==0) dropobj(); return;	/*	to drop an object	*/

			case 'c':	yrepcount=0;	cast();		return;		/*	cast a spell	*/

			case 'i':	yrepcount=0;	nomove=1;  showstr();	return;		/*	status		*/

			case 'e':	yrepcount=0;
						if (c[TIMESTOP]==0) eatcookie(); return;	/*	to eat a fortune cookie */

			case 'D':	yrepcount=0;	seemagic(0);	nomove=1; return;	/*	list spells and scrolls */

			case '?':	yrepcount=0;	help(); nomove=1; return;	/*	give the help screen*/

			case 'S':	clear();  lprcat("Saving . . ."); lflush();  
						savegame(savefilename); wizard=1; died(-257);	/*	save the game - doesnt return	*/

			case 'Z':	yrepcount=0;	if (c[LEVEL]>9) { oteleport(1); return; }
						cursor(1,21); lprcat("\nAs yet, you don't have enough experience to use teleportation");
						return;	/*	teleport yourself	*/

			case '^':	/* identify traps */  flag=yrepcount=0;  cursor(1,21);
						lprc('\n');  for (j=playery-1; j<playery+2; j++)
							{
							if (j < 0) j=0;		if (j >= MAXY) break;
							for (i=playerx-1; i<playerx+2; i++)
								{
								if (i < 0) i=0;	if (i >= MAXX) break;
								switch(item[i][j])
									{
									case OTRAPDOOR:		case ODARTRAP:
									case OTRAPARROW:	case OTELEPORTER:
										lprcat("\nIts "); lprcat(objectname[item[i][j]]);  flag++;
									};
								}
							}
						if (flag==0) lprcat("\nNo traps are visible");
						return;

#ifdef WIZZARD
			case '_':	/*	this is the fudge player password for wizard mode*/
						yrepcount=0;	cursor(1,21); nomove=1;
						if (userid!=wisid)
							{
							lprcat("Sorry, you are not empowered to be a wizard.\n");
							scbr(); /* system("stty -echo cbreak"); */
							lflush();  return;
							}
						if (getpassword()==0)
							{
							scbr(); /* system("stty -echo cbreak"); */ return;
							}
						wizard=1;  scbr(); /* system("stty -echo cbreak"); */
						for (i=0; i<6; i++)  c[i]=70;  iven[0]=iven[1]=0;
						take(OPROTRING,50);   take(OLANCE,25);  c[WIELD]=1;
						c[LANCEDEATH]=1;
						raiseexperience(6000000);  c[AWARENESS] += 25000;
						{
						register int i,j,k;
						for (i=0; i<MAXY; i++)
							for (j=0; j<MAXX; j++)  know[j][i]=1;
						for (i=0; i<SPNUM; i++)	spelknow[i]=1;
						for (i=0; i<MAXSCROLL; i++)  scrollname[i][0]=' ';
						for (i=0; i<MAXPOTION; i++)  potionname[i][0]=' ';
						}
						for (i=0; i<MAXSCROLL; i++) { item[i][0]=OSCROLL; iarg[i][0]=i; }
						for (i=MAXX-1; i>MAXX-1-MAXPOTION; i--)
							{ item[i][0]=OPOTION; iarg[i][0]=i-MAXX+MAXPOTION; }
						for (i=1; i<MAXY; i++)
							{ item[0][i]=i; iarg[0][i]=0; }
						for (i=MAXY; i<MAXY+MAXX; i++)
							{ item[i-MAXY][MAXY-1]=i; iarg[i-MAXY][MAXY-1]=0; }
						for (i=MAXX+MAXY; i<MAXX+MAXY+MAXY; i++)
							{ item[MAXX-1][i-MAXX-MAXY]=i; iarg[MAXX-1][i-MAXX-MAXY]=0; }
						c[GOLD]+=250000;	drawscreen();	return;
#endif

			case 'T':	yrepcount=0;	cursor(1,21);  if (c[SHIELD] != -1) { c[SHIELD] = -1; lprcat("\nYour shield is off"); bottomline(); } else
										if (c[WEAR] != -1) { c[WEAR] = -1; lprcat("\nYour armor is off"); bottomline(); }
						else lprcat("\nYou aren't wearing anything");
						return;

			case 'g':	cursor(1,21);
						lprintf("\nThe stuff you are carrying presently weighs %d pounds",packweight());
			case ' ':	yrepcount=0;	nomove=1;  return;

			case 'v':	yrepcount=0;	cursor(1,21);
						lprintf("\nCaverns of Larn, Version %d.%d by Noah Morgan, Diff=%d",VERSION,SUBVERSION,c[HARDGAME]);
						if (wizard) lprcat(" Wizard"); nomove=1; return;

			case 'Q':	yrepcount=0;	quit(); nomove=1;	return;	/*	quit		*/

			case 'L'-64:  yrepcount=0;	drawscreen();  nomove=1; return;	/*	look		*/

#ifdef WIZZARD
#ifdef EXTRA
			case 'A':	yrepcount=0;	nomove=1; if (wizard) return(diag());  /*	create diagnostic file */
#endif
#endif
			case 'P':	cursor(1,21); 
						if (outstanding_taxes>0)
							lprintf("\nYou presently owe %d gp in taxes.",outstanding_taxes);
						else
							lprintf("\nYou do not owe any taxes.");
						return;
			};
		}
	}

parse2()
	{
	if (c[HASTEMONST]) movemonst(); movemonst(); /*	move the monsters		*/
	randmonst();	regen();
	}

run(dir)
	int dir;
	{
	register int i;
	i=1; while (i)
		{
		i=moveplayer(dir);
		if (i>0) {  if (c[HASTEMONST]) movemonst();  movemonst(); randmonst(); regen(); }
		if (hitflag) i=0;	if (i!=0)  showcell(playerx,playery);
		}
	}

/*
	function to wield a weapon
 */
wield()	
	{
	register int i;
	while (1)
		{
		if ((i = whatitem("wield"))=='\33')  return;
		if (i != '.')
			{
			if (i=='*') showwield();
			else  if (iven[i-'a']==0) { ydhi(i); return; }
			else if (iven[i-'a']==OPOTION) { ycwi(i); return; }
			else if (iven[i-'a']==OSCROLL) { ycwi(i); return; }
			else  if ((c[SHIELD]!= -1) && (iven[i-'a']==O2SWORD)) { lprcat("\nBut one arm is busy with your shield!"); return; }
			else  { c[WIELD]=i-'a'; if (iven[i-'a'] == OLANCE) c[LANCEDEATH]=1; else c[LANCEDEATH]=0;  bottomline(); return; }
			}
		}
	}

/*
	common routine to say you dont have an item
 */
ydhi(x)
	int x;
	{ cursor(1,21);  lprintf("\nYou dont have item %c!",x); }
ycwi(x)
	int x;
	{ cursor(1,21);  lprintf("\nYou can't wield item %c!",x); }

/*
	function to wear armor
 */
wear()
	{
	register int i;
	while (1)
		{
		if ((i = whatitem("wear"))=='\33')  return;
		if (i != '.')
			{
			if (i=='*') showwear(); else
			switch(iven[i-'a'])
				{
				case 0:  ydhi(i); return;
				case OLEATHER:  case OCHAIN:  case OPLATE:	case OSTUDLEATHER:
				case ORING:		case OSPLINT:	case OPLATEARMOR:	case OSSPLATE:
						if (c[WEAR] != -1) { lprcat("\nYou're already wearing some armor"); return; }
							c[WEAR]=i-'a';  bottomline(); return;
				case OSHIELD:	if (c[SHIELD] != -1) { lprcat("\nYou are already wearing a shield"); return; }
								if (iven[c[WIELD]]==O2SWORD) { lprcat("\nYour hands are busy with the two handed sword!"); return; }
								c[SHIELD] = i-'a';  bottomline(); return;
				default:	lprcat("\nYou cant wear that!");
				};
			}
		}
	}

/*
	function to drop an object
 */
dropobj()
	{
	register int i;
	int amt;
	while (1)
		{
		if ((i = whatitem("drop"))=='\33')  return;
		if (i=='*') showstr(); else 
			{
			if (i=='.')	/* drop some gold */
				{
				if (item[playerx][playery]) return(lprcat("\nThere's something here already!"));
				lprcat("\nHow much gold do you drop? ");
				if ((amt=readnum(c[GOLD])) == 0) return;
				if (amt>c[GOLD]) return(lprcat("\nYou dont have that much!"));
				if (amt<256)
					{ item[playerx][playery]=OGOLDPILE; i=amt; }
				else if (amt<2551)
					{ item[playerx][playery]=ODGOLD; i=amt/10; amt = 10*i; }
				else if (amt<25501)
					{ item[playerx][playery]=OMAXGOLD; i=amt/100; amt = 100*i; }
				else if (amt<255001)
					{ item[playerx][playery]=OKGOLD; i=amt/1000; amt = 1000*i; }
				else
					{ item[playerx][playery]=OKGOLD; i=255; amt = 255000; }
				c[GOLD] -= amt; 
				lprintf("\nYou drop %d gold pieces",amt);
				iarg[playerx][playery]=i; bottomgold();
				know[playerx][playery]=0; dropflag=1;  return;
				}
			return(drop_object(i-'a'));
			}
		}
	}

/*
	subroutine to read a scroll one is carrying
 */
readscr()
	{
	register int i;
	while (1)
		{
		if ((i = whatitem("read"))=='\33')  return;
		if (i != '.')
			{
			if (i=='*') showread(); else
				{
				if (iven[i-'a']==OSCROLL) { read_scroll(ivenarg[i-'a']); iven[i-'a']=0; return; }
				if (iven[i-'a']==OBOOK)   { readbook(ivenarg[i-'a']);  iven[i-'a']=0; return; }
				if (iven[i-'a']==0) { ydhi(i); return; }
				lprcat("\nThere's nothing on it to read");  return;
				}
			}
		}
	}

/*
 *	subroutine to eat a cookie one is carrying
 */
eatcookie()
{
register int i;
char *p;
while (1)
	{
	if ((i = whatitem("eat"))=='\33')  return;
	if (i != '.')
		if (i=='*') showeat(); else
			{
			if (iven[i-'a']==OCOOKIE)
				{
				lprcat("\nThe cookie was delecious.");
				iven[i-'a']=0;
				if (!c[BLINDCOUNT])
					{
					if (p=fortune(fortfile))
						{
						lprcat("  Inside you find a scrap of paper that says:\n");
						lprcat(p);
						}
					}
				return;
				}
			if (iven[i-'a']==0) { ydhi(i); return; }
			lprcat("\nYou can't eat that!");  return;
			}
	}
}

/*
 *	subroutine to quaff a potion one is carrying
 */
quaff()
	{
	register int i;
	while (1)
		{
		if ((i = whatitem("quaff"))=='\33')  return;
		if (i != '.')
			{
			if (i=='*') showquaff(); else
				{
				if (iven[i-'a']==OPOTION) { quaffpotion(ivenarg[i-'a']); iven[i-'a']=0; return; }
				if (iven[i-'a']==0) { ydhi(i); return; }
				lprcat("\nYou wouldn't want to quaff that, would you? ");  return;
				}
			}
		}
	}

/*
	function to ask what player wants to do
 */
whatitem(str)
	char *str;
	{
	int i;
	cursor(1,21);  lprintf("\nWhat do you want to %s [* for all] ? ",str);
	i=0; while (i>'z' || (i<'a' && i!='*' && i!='\33' && i!='.')) i=getchar();
	if (i=='\33')  lprcat(" aborted");
	return(i);
	}

/*
	subroutine to get a number from the player
	and allow * to mean return amt, else return the number entered
 */
readnum(mx)
	int mx;
	{
	register int i,amt;
	sncbr(); lflush(); amt=0;
	i=getchar();  if (i=='\033') { scbr(); lprcat(" aborted"); return(0); }
	if (i == '*')  amt = mx;	/* allow him to say * for all gold */
	else
		while (i != '\n')
			{
			if ((i <= '9') && (i >= '0'))  amt = amt*10+i-'0';
			i = getchar();
			}
	scbr();  return(amt);
	}

/*
 *	routine to zero every byte in a string
 */
szero(str)
	register char *str;
	{
	while (*str)
		{
		*str++ = 0;
		}
	}

#ifdef TIMECHECK
/*
 *	routine to check the time of day and return 1 if its during work hours
 */
int playable()
	{
	long gtime,time();
	int hour;
	char *ctime(),*date;
	time(&gtime);	date = ctime(&gtime);
	hour = (date[11]-'0')*10 + date[12]-'0';
	if (((hour>=9 && hour<12) || (hour>=13 && hour<17)) && strncmp("Sat",date,3)!=0 && strncmp("Sun",date,3)!=0)
		return(1);
	return(0);
	}
#endif TIMECHECK

fixstrings()
	{
	strcat(scorefile, SCORENAME);
	strcat(logfile, LOGFNAME);
	strcat(mail601, MAIL601);
	strcat(mail602, MAIL602);
	strcat(mail603, MAIL603);
	strcat(mail604, MAIL604);
	strcat(mail605, MAIL605);
	strcat(helpfile, HELPNAME);
	strcat(larnlevels, LEVELSNAME);
	strcat(fortfile, FORTSNAME);
	}
