/*	movem.c		*/
#include "header.h"
static char copyright[]="Larn is copyrighted 1986 by Noah Morgan.\n";
extern short playerx,playery,hitp[MAXX][MAXY],lasthx,lasthy;
extern int c[],gtime,yrepcount;
extern char item[MAXX][MAXY],know[MAXX][MAXY],mitem[MAXX][MAXY];
extern char iarg[MAXX][MAXY];
extern char stealth[MAXX][MAXY],screen[MAXX][MAXY],level;
extern struct monst monster[];
/*
	routine to move the monsters toward the player
 */
/*
	routine to move the monsters toward the player
 */
static int w1[9],w1x[9],w1y[9],wtmp;
static int tmp1,tmp2,tmp3,tmp4;
movemonst()
	{
	register int i,j;
	if (c[TIMESTOP]) return;
	if (c[HASTESELF])  if ((c[HASTESELF]&1)==0)  return;
	if (c[SPHCAST]) movsphere();	/* move the spheres of annialation if any */
	if (c[HOLDMONST])  return;
	if (c[AGGRAVATE])
	  { tmp1=playery-5; tmp2=playery+6; tmp3=playerx-10; tmp4=playerx+11; }
	else
	  { tmp1=playery-3; tmp2=playery+4; tmp3=playerx-5; tmp4=playerx+6; }

	if (level == 0)	/* if on outside level monsters can move in perimeter */
		{
		if (tmp1 < 0) tmp1=0;		 if (tmp2 > MAXY) tmp2=MAXY;
		if (tmp3 < 0) tmp3=0;		 if (tmp4 > MAXX) tmp4=MAXX;
		}
	else	/* if in a dungeon monsters cant be on the perimeter (wall there) */
		{
		if (tmp1 < 1) tmp1=1;		 if (tmp2 > MAXY-1) tmp2=MAXY-1;
		if (tmp3 < 1) tmp3=1;		 if (tmp4 > MAXX-1) tmp4=MAXX-1;
		}

	if ((c[AGGRAVATE]) || (c[STEALTH]==0))
		{
		for (j=tmp1; j<tmp2; j++)
			for (i=tmp3; i<tmp4; i++)
				if (mitem[i][j]) if (know[i][j]<=1)  movemt(i,j);
		} else
		{
		for (j=tmp1; j<tmp2; j++)
			for (i=tmp3; i<tmp4; i++)
				if (mitem[i][j]) if (know[i][j]<=1)  if (stealth[i][j]) movemt(i,j);
		}

	if (mitem[lasthx][lasthy])
		{
		if ((lasthx < tmp3) || (lasthx >= tmp4) || (lasthy < tmp1) || (lasthy >= tmp2))
				{
				movemt(lasthx,lasthy);
				lasthx = w1x[0];   lasthy = w1y[0];
				know[lasthx][lasthy] &= 1;
				}
		}

	for (j=tmp1; j<tmp2; j++) for (i=tmp3; i<tmp4; i++) know[i][j] &= 1;
	}

static int tmpitem,xl,xh,yl,yh;
movemt(i,j)
	int i,j;
	{
	register int k,m,tmp;
	switch(mitem[i][j])  /* for half speed monsters */
		{
		case TROGLODYTE:  case HOBGOBLIN:  case METAMORPH:  case XVART:
		case INVISIBLESTALKER:  case ICELIZARD: if ((gtime & 1) == 1) return;
		};

	if (c[SCAREMONST])
		{
		if ((xl = i+rnd(3)-2) < 0) xl=0;  if (xl >= MAXX) xl=MAXX-1;
		if ((yl = j+rnd(3)-2) < 0) yl=0;  if (yl >= MAXY) yl=MAXY-1;
		if ((tmp=item[xl][yl]) != OWALL)
		  if (mitem[xl][yl] == 0)
			if ((mitem[i][j] != VAMPIRE) || (tmpitem != OMIRROR))
			  if (tmp != OCLOSEDDOOR)		mmove(i,j,xl,yl);
		return;
		}
	xl=i-1;  yl=j-1;  xh=i+2;  yh=j+2;
	if (i<playerx) xl++; else if (i>playerx) --xh;
	if (j<playery) yl++; else if (j>playery) --yh;
	for (k=0; k<9; k++) w1[k] = 10000;

	for (k=xl; k<xh; k++)
		for (m=yl; m<yh; m++)
			{
			tmp = k-i+4+3*(m-j);
			tmpitem = item[k][m];
			if (tmpitem!=OWALL || (k==playerx && m==playery))
			 if (mitem[k][m]==0)
			  if ((mitem[i][j] != VAMPIRE) || (tmpitem != OMIRROR))
				 if (tmpitem!=OCLOSEDDOOR)
					{
					w1[tmp] = (playerx-k)*(playerx-k)+(playery-m)*(playery-m);
					w1x[tmp] = k;  w1y[tmp] = m;
					}
			}

	tmp = 0;
	for (k=1; k<9; k++)  if (w1[tmp] > w1[k])  tmp=k;

	if (w1[tmp] < 10000)
		if ((i!=w1x[tmp]) || (j!=w1y[tmp]))  mmove(i,j,w1x[tmp],w1y[tmp]);
	}

int oldrep=0;
mmove(aa,bb,cc,dd)
	int aa,bb,cc,dd;
	{
	register int tmp,i,flag;
	char *who;
	int j;
	flag=0;	/* set to 1 if monster hit by arrow trap */
	if ((cc==playerx) && (dd==playery))		return(hitplayer(aa,bb));
	i=item[cc][dd];
	if ((i==OPIT) || (i==OTRAPDOOR))
	  switch(mitem[aa][bb])
		{
		case SPIRITNAGA:	case PLATINUMDRAGON:	case WRAITH:
		case VAMPIRE:		case SILVERDRAGON:		case POLTERGEIST:
		case DEMONLORD:		case DEMONLORD+1:		case DEMONLORD+2:
		case DEMONLORD+3:	case DEMONLORD+4:		case DEMONLORD+5:
		case DEMONLORD+6:	case DEMONPRINCE:	break;

		default:	mitem[aa][bb]=0; /* fell in a pit or trapdoor */
		};
	tmp = mitem[cc][dd] = mitem[aa][bb];
	if (i==OANNIALATION)
		{
		if (tmp>=DEMONLORD+3) /* demons dispell spheres */
			{
			cursor(1,21);
			lprintf("\nThe %s dispells the sphere!",monster[tmp].name);
			item[cc][dd]=0;  show1cell(cc,dd);
			}
		else i=tmp=mitem[cc][dd]=0;
		}
	stealth[cc][dd]=1;
	if ((hitp[cc][dd] = hitp[aa][bb]) < 0) hitp[cc][dd]=1;
	mitem[aa][bb] = 0;				know[cc][dd] += 2;
	if (tmp == LEPRECHAUN)
		switch(i)
			{
			case OGOLDPILE:  case OMAXGOLD:  case OKGOLD:  case ODGOLD:
			case ODIAMOND:   case ORUBY:     case OEMERALD: case OSAPHIRE:
					item[cc][dd] = 0; /* leprechaun takes gold */
			};

	if (tmp == TROLL)  /* if a troll regenerate him */
		if ((gtime & 1) == 0)
			if (monster[tmp].hitpoints > hitp[cc][dd])  hitp[cc][dd]++;

	if (i==OTRAPARROW)	/* arrow hits monster */
		{ who = "An arrow";  if ((hitp[cc][dd] -= rnd(10)+level) <= 0)
			{ mitem[cc][dd]=0;  flag=2; } else flag=1; }
	if (i==ODARTRAP)	/* dart hits monster */
		{ who = "A dart";  if ((hitp[cc][dd] -= rnd(6)) <= 0)
			{ mitem[cc][dd]=0;  flag=2; } else flag=1; }
	if (i==OTELEPORTER)	/* monster hits teleport trap */
		{ flag=3; fillmonst(mitem[cc][dd]);  mitem[cc][dd]=0; }
	if (c[BLINDCOUNT]) return;	/* if blind dont show where monsters are	*/
	if (know[cc][dd] & 1) 
		{
		if (flag) cursor(1,21);
		if (flag==1) lprintf("\n\7%s hits the %s",who,monster[tmp].name); else
		if (flag==2) lprintf("\n\7%s hits and kills the %s",who,monster[tmp].name); else
		if (flag==3) lprintf("\n\7The %s gets teleported",monster[tmp].name);
		}
/*	if (yrepcount>1) { know[aa][bb] &= 2;  know[cc][dd] &= 2; return; } */
	if (know[aa][bb] & 1)   show1cell(aa,bb);
	if (know[cc][dd] & 1)   show1cell(cc,dd);
	}

/*
 *	function to look for and move spheres of annialation
 *	iarg = 	[3 bits direction] [5 bits duration]
 */
movsphere()
	{
	register char *p,*pe;
	register int i,j,k;
	int newi,newj,m,tim,ni;
	char *mes;
	extern char diroffx[],diroffy[];
	for (p= &screen[0][0],pe=p+MAXX*MAXY; p<pe; *p++ = 1); /* set up the already moved flags */

	for (i=0; i<MAXY; i++)
		for (j=0; j<MAXX; j++)
			if ((item[j][i]==OANNIALATION) && (screen[j][i]))
				{
				k = iarg[j][i];	/* direction and duration */
				k &= 255;  tim = k&31;
				if (--tim < 0)	/* has sphere run out of gas? */
					{
					--c[SPHCAST];	/* one less sphere of annialation */
					item[j][i]=0, know[j][i]=1; show1cell(j,i); continue;
					}
				else { tim |= ((k>>5)<<5);  k=iarg[j][i]=tim; }
				/* time to move the sphere */
				switch(rnd(max(7,c[INTELLIGENCE]>>1)))
					{
					case 1:
					case 2:		/* change direction to a random one */
								k = k&31 | (rund(8)<<5);
					default:	/* move in normal direction */
								item[j][i]=0, know[j][i]=1; show1cell(j,i);
								m = ((k>>5)&7)+1;
								newi = i + diroffy[m];  newj = j + diroffx[m];
								if (newi<1) newi=1;     if (newj<1) newj=1;
								if (newi>=MAXY-1) newi=MAXY-2;
								if (newj>=MAXX-1) newj=MAXX-2;
								ni=item[newj][newi];
								if (mitem[newj][newi]>=DEMONLORD)
									{
									cursor(1,21);
									lprintf("\nThe %s dispells the sphere!",monster[mitem[newj][newi]].name);
									}
								else if (ni==OANNIALATION || mitem[newj][newi]==DISENCHANTRESS || c[CANCELLATION])
									{
									if (c[CANCELLATION]) mes="cancellation takes effect,"; else
									if (ni==OANNIALATION) mes="spheres collide,";
										else mes="disenchantress cancells the sphere";
									cursor(1,21); lprintf("\n\7As the %s you hear a great earth shaking blast!",mes);
									if (c[HOLDMONST]) c[HOLDMONST]=1;
									if (c[CANCELLATION]) c[CANCELLATION]=1;
									for (j=max(1,newj-2); j<min(newj+3,MAXX-1); j++)
									  for (i=max(1,newi-2); i<min(newi+3,MAXY-1); i++)
										{
										item[j][i]=mitem[j][i]=know[j][i]=0;
										if (playerx==j && playery==i)
											{
											lprcat("\n\7You were too close to the sphere!");
											nap(3000);
											died(283); /* player killed in explosion */
											}
										}
									k=c[AWARENESS]; c[AWARENESS]=100;
									showcell(newj,newi); c[AWARENESS]=k;
									/* show blast area with expanded awareness */
									}
								else
									{
									item[newj][newi]=OANNIALATION;
									iarg[newj][newi]=k;
									mitem[newj][newi]=0;
									screen[newj][newi]=0; /* say already moved */
									}
								show1cell(newj,newi);
					};
				}
	}

