/*
 *	config.c	--	This defines the installation dependent variables.
 *                  Some strings are modifified later.  ANSI C would
 *                  allow compile time string concatenation, we must
 *                  do runtime concatenation, in main.
 */
static char copyright[]="Larn is copyrighted 1986 by Noah Morgan.\n";

#include "header.h"

#ifndef LARNHOME
#define LARNHOME "/usr/games/larn/"		/* normally supplied by a Makefile */
#endif

#ifndef WIZID
#define WIZID	0
#endif

/* All these strings will be appended to in main() to be complete filenames */

		/* the game save filename   */
char savefilename[128] = 								LARNHOME;

		/* the score file	    	*/
char scorefile[sizeof(LARNHOME)+sizeof(SCORENAME)] =	LARNHOME;

		/* the logging file     	*/
char logfile[sizeof(LARNHOME)+sizeof(LOGFNAME)]  =		LARNHOME;

		/* mail text if win game    */
char mail601[sizeof(LARNHOME)+sizeof(MAIL601)]  =		LARNHOME;
char mail602[sizeof(LARNHOME)+sizeof(MAIL602)]  =		LARNHOME;
char mail603[sizeof(LARNHOME)+sizeof(MAIL603)]  =		LARNHOME;
char mail604[sizeof(LARNHOME)+sizeof(MAIL604)]  =		LARNHOME;
char mail605[sizeof(LARNHOME)+sizeof(MAIL605)]  =		LARNHOME;

		/* the help text file		*/
char helpfile[sizeof(LARNHOME)+sizeof(HELPNAME)] = 		LARNHOME;

		/* the maze data file		*/
char larnlevels[sizeof(LARNHOME)+sizeof(LEVELSNAME)] = 	LARNHOME;

		/* the fortune data file	*/
char fortfile[sizeof(LARNHOME)+sizeof(FORTSNAME)] =		LARNHOME;

char *diagfile ="diagfile";						/* the diagnostic filename	*/
char *optsfile ="/.larnopts";					/* the option file			*/
char *ckpfile  ="Larn11.0.ckp";					/* the checkpoint filename	*/
char *password ="nudist";					/* the wizards password <=32*/
int wisid=WIZID;		/* the user id of the only person who can be wizard */
char psname[40]="larn";							/* the process name		*/
